module dmd.ProtDeclaration;

import dmd.AttribDeclaration;
import dmd.PROT;
import dmd.OutBuffer;
import dmd.HdrGenState;
import dmd.Scope;
import dmd.Dsymbol;
import dmd.Array;

class ProtDeclaration : AttribDeclaration
{
    PROT protection;

    this(PROT p, Array decl)
	{
		super(decl);

		protection = p;
		//printf("decl = %p\n", decl);
	}
	
    Dsymbol syntaxCopy(Dsymbol s)
	{
		assert(false);
	}
	
    void setScope(Scope sc)
	{
		if (decl)
		{
			setScopeNewSc(sc, sc.stc, sc.linkage, protection, 1, sc.structalign);
		}
	}
	
    void semantic(Scope sc)
	{
		if (decl)
		{
			semanticNewSc(sc, sc.stc, sc.linkage, protection, 1, sc.structalign);
		}
	}
	
    void toCBuffer(OutBuffer buf, HdrGenState* hgs)
	{
		assert(false);
	}

    static void protectionToCBuffer(OutBuffer buf, PROT protection)
	{
		assert(false);
	}
}